CREATE OR REPLACE TRIGGER LOG_OPL_GERA_SAIDA_OL
AFTER INSERT OR UPDATE
ON LOGSAIDAOL FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(1500);
  V_CDFILLOGOPER VARCHAR2(4);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_IDPARAM      VARCHAR2(1);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   V_DESC   :=        'Filial OL:'             ||''  || NVL(:NEW.CDFILIOPELOG,'')       ||'  '  ||
                      'Dt. Entrega:'           ||''  || NVL(:NEW.DTPROGENPEOL,'')       ||'  '  ||
                      'Dt.Embarque:'           ||''  || NVL(:NEW.DTPROGEMBARQ,'')       ||'  '  ||
                      'Lista Rota:'            ||''  || NVL(:NEW.CDROTATRANS,'')       ||'  '  ||
                      'Lista SubGrupo:'        ||''  || NVL(:NEW.CDSUBGRPROD,'')    ||'  '  ||
                      'Pedido Extra:'          ||''  || NVL(:NEW.IDEXPTITMOLEXP,'')     ||'  '  ||
                      'Lote:'                  ||''  || NVL(:NEW.CDLOTENVITOL,'');

   V_ITPESQ       := :NEW.CDFILIOPELOG;
   V_CDFILLOGOPER := :NEW.CDFILIOPELOG;
   V_IDTIPOOPER   := '1';
   IF (V_DESC IS NOT NULL)   THEN
      V_DESC := SUBSTR(V_DESC, 1, 300);
      INSERT INTO LOGOPERA
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM,
          DSRDMUSUOPER,
          DSENDUSUOPER,
          DSNMUSUOPER,
          DSMETUSUOPER,
          CDORESPOPER,
          CDFILLOGOPER)
      VALUES
         ('LOGSAIDAOL',
          SYSDATE,
          NVL(V_NMOPERADOR,' '),
          V_IDTIPOOPER,
          V_DESC,
          V_ITPESQ,
          V_DSSERVERRDM,
          V_DSREMOTEADDR,
          V_DSREMOTEHOST,
          V_DSSERVMETHOD,
          V_DSREMOTEOPER,
          V_CDFILLOGOPER);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_OPL_GERA_SAIDA_OL','5.33.XXX'); END;
/
