function Cus00500_ParametrosDeCustos_Controller(ScreenService, General, Parametros, templateManager, Cus00500_ParametrosDeCustos_Service) {

    this.fillCheckBox = function(widget) {
        var widgetGeral = widget.container.getWidget('tabbedGeral');
        widget.dataSource.data.forEach(function (row) {
            if (widgetGeral.dataSource.data.length > 0)
                row.NMMOEDCUSTO = row.IDMOEDCUSTO == 1 ? widgetGeral.dataSource.data[0].NMINDICE : (row.IDMOEDCUSTO == 2 ? widgetGeral.dataSource.data[0].NMINDICE2 : '');
            
            if (row.IDUTTPCUSTO == 'S') {
                row.__isSelected = true;
            } else {
                row.__isSelected = false;
            }
        });
    };
    
    this.checkRow = function(widget) {
        widget.selectedRow.IDUTTPCUSTO = widget.selectedRow.__isSelected ? 'S' : 'N';
        Cus00500_ParametrosDeCustos_Service.updateTipoCusto(widget.selectedRow).then(function(success) {
            widget.reload();
        });
    };
    
    this.checkAll = function(widget, action) {
        var message = action == 'selectAll' ? 'Tem certeza que deseja selecionar todos os tipos de custo?' : 'Tem certeza que deseja desmarcar todos os tipos de custo?';
        ScreenService.confirmMessage(message, 'question', function (success) {
            widget.dataSource.data.forEach(function(row) {
                row.IDUTTPCUSTO = row.__isSelected ? 'S' : 'N';
                Cus00500_ParametrosDeCustos_Service.updateTipoCusto(row);
            });
            widget.reload();
        }, function (error) {
            widget.reload();
        });
    };
    
    this.setTabbedFilialDefaultValues = function(widgetFilial) {
        widgetFilial.currentRow.NMFILIAL = getLocalVar('CDFILIAL') + " | " + getLocalVar('NMFILIAL');
        widgetFilial.currentRow.CDFILIAL = getLocalVar('CDFILIAL');
        
        this.setTabbedFilialDatasourceFilter(widgetFilial);
    };
    
    this.setTabbedFilialDatasourceFilter = function(widgetFilial) {
    if(widgetFilial.currentRow.NMFILIAL === ''){
        widgetFilial.getField('IDCOMCUSPERC').readOnly = true;
        widgetFilial.getField('VRDIFCUSTACAO').readOnly = true;
    }
    else{
        widgetFilial.getField('IDCOMCUSPERC').readOnly = false;
        widgetFilial.getField('VRDIFCUSTACAO').readOnly = false;
    }
        var dataSourceFilter = [
            {
                "name": "CDFILIAL",
                "value": widgetFilial.currentRow.CDFILIAL,
                "operator": "="
            }
        ];
        
        widgetFilial.dataSourceFilter = dataSourceFilter;
        widgetFilial.reload();
    };
    
    this.updateTabbedFilialValues = function(widgetFilial) {
        if (widgetFilial.dataSource.data.length > 0) {
            widgetFilial.currentRow.VRDIFCUSTACAO = widgetFilial.dataSource.data[0].VRDIFCUSTACAO;
            widgetFilial.currentRow.IDCOMCUSPERC = widgetFilial.dataSource.data[0].IDCOMCUSPERC;
        }
    };
    
    this.setDefaultValues = function(widgetGeral) {
        var widgetMoeda = widgetGeral.container.getWidget('tabbedMoeda');
        var widgetCusto = widgetGeral.container.getWidget('tabbedCusto');
        var widgetCurva = widgetGeral.container.getWidget('tabbedCurva');
        
        widgetMoeda.currentRow.CDINDICEMF = widgetGeral.dataSource.data[0].CDINDICEMF;
        widgetMoeda.currentRow.NMINDICE = widgetGeral.dataSource.data[0].NMINDICE;
        widgetMoeda.currentRow.CDINDICEMF2 = widgetGeral.dataSource.data[0].CDINDICEMF2;
        widgetMoeda.currentRow.NMINDICE2 = widgetGeral.dataSource.data[0].NMINDICE2;
        
        widgetCusto.currentRow.QTBLOQNESTOP = widgetGeral.dataSource.data[0].QTBLOQNESTOP;
        widgetCusto.currentRow.QTLIBENESTOR = widgetGeral.dataSource.data[0].QTLIBENESTOR;
        
        widgetCurva.currentRow.VRPECURVAA = widgetGeral.dataSource.data[0].VRPECURVAA;
        widgetCurva.currentRow.VRPECURVAB = widgetGeral.dataSource.data[0].VRPECURVAB;
        widgetCurva.currentRow.VRPECURVAC = widgetGeral.dataSource.data[0].VRPECURVAC;
    };
    
    this.cancelTabbedGeral = function(widget) {
        var widgetGeral = widget.parent;
        widgetGeral.reload();
        this.setDefaultValues(widgetGeral);
        widgetGeral.currentRow.changed = false;
        widget.list();
        ativaTabbed(widget);
        widget.childTemplate = "widget/form.html";
        templateManager.updateTemplate();
    };
    
    function ativaTabbed(widget){
        widget.container.eachWidget(function (widgetTabbed) {
			widgetTabbed.enabled = true;
		});
    }
    
    this.widgetIsValid = function(widget) {
        if (widget.name == "tabbedMoeda" && widget.currentRow.CDINDICEMF && widget.currentRow.CDINDICEMF2 && widget.currentRow.CDINDICEMF == widget.currentRow.CDINDICEMF2) {
            ScreenService.showMessage("Índices 1 e 2 não podem ser iguais.");
            return false;
        } else if (widget.name == "tabbedCusto") {
            if (widget.currentRow.QTBLOQNESTOP < 0) {
                ScreenService.showMessage("Quantidade de Meses Futuros deve ser maior ou igual a zero.");
                return false;
            } else if (widget.currentRow.QTLIBENESTOR < 1) {
                ScreenService.showMessage("Quantidade de Meses Passados deve ser maior ou igual a um.");
                return false;
            }
        } else if (widget.name == "tabbedCurva") {
            var VRPECURVAA = (typeof widget.currentRow.VRPECURVAA === 'string' && !Util.isEmptyOrBlank(widget.currentRow.VRPECURVAA)) ? parseInt(widget.currentRow.VRPECURVAA.split("%")[0]) : widget.currentRow.VRPECURVAA;
            var VRPECURVAB = (typeof widget.currentRow.VRPECURVAB === 'string' && !Util.isEmptyOrBlank(widget.currentRow.VRPECURVAB)) ? parseInt(widget.currentRow.VRPECURVAB.split("%")[0]) : widget.currentRow.VRPECURVAB;
            var VRPECURVAC = (typeof widget.currentRow.VRPECURVAC === 'string' && !Util.isEmptyOrBlank(widget.currentRow.VRPECURVAC)) ? parseInt(widget.currentRow.VRPECURVAC.split("%")[0]) : widget.currentRow.VRPECURVAC;
            var soma = VRPECURVAA + VRPECURVAB + VRPECURVAC;
            
            if (VRPECURVAA < 0) {
                ScreenService.showMessage("Valor percentual da curva A deve ser maior ou igual a zero.");
                return false;
            } else if (VRPECURVAB < 0) {
                ScreenService.showMessage("Valor percentual da curva B deve ser maior ou igual a zero.");
                return false;
            } else if (VRPECURVAC < 0) {
                ScreenService.showMessage("Valor percentual da curva C deve ser maior ou igual a zero.");
                return false;
            } else if (soma != 100) {
                ScreenService.showMessage("Somatório dos percentuais das curvas deve totalizar 100%.");
                return false;
            }
        }
        
        return true;
    };
    
    this.isString = function(param) {
        if (typeof param === 'string')
            return true;
            
        return false;
    };
    
    this.saveTabbedGeral = function(widget) {
        if (this.widgetIsValid(widget)) {
            var widgetGeral = widget.parent;
            var row = widgetGeral.dataSource.data[0];
            
            if (widget.name == "tabbedMoeda") {
                row.CDINDICEMF = widget.currentRow.CDINDICEMF;
                row.NMINDICE = widget.currentRow.NMINDICE;
                row.CDINDICEMF2 = widget.currentRow.CDINDICEMF2;
                row.NMINDICE2 = widget.currentRow.NMINDICE2;
            } else if (widget.name == "tabbedCusto") {
                row.QTBLOQNESTOP = widget.currentRow.QTBLOQNESTOP;
                row.QTLIBENESTOR = widget.currentRow.QTLIBENESTOR;
            } else if (widget.name == "tabbedCurva") {
                row.VRPECURVAA = (typeof widget.currentRow.VRPECURVAA === 'string') ? parseInt(widget.currentRow.VRPECURVAA.split("%")[0], 10) : widget.currentRow.VRPECURVAA;
                row.VRPECURVAB = (typeof widget.currentRow.VRPECURVAB === 'string') ? parseInt(widget.currentRow.VRPECURVAB.split("%")[0], 10) : widget.currentRow.VRPECURVAB;
                row.VRPECURVAC = (typeof widget.currentRow.VRPECURVAC === 'string') ? parseInt(widget.currentRow.VRPECURVAC.split("%")[0], 10) : widget.currentRow.VRPECURVAC;
            }
            
            Cus00500_ParametrosDeCustos_Service.updateTabbedGeral(row).then(function(success) {
                ScreenService.notificationMessage("Alterações realizadas com sucesso!", 'success');
                widget.container.getWidget('gridIndiceTipoCusto').reload();
                this.cancelTabbedGeral(widget);
                ativaTabbed(widget);
            }.bind(this)).catch(function(e){
                ScreenService.showMessage(e);
            });
        }
    };
    
    this.cancelTabbedFilial = function(widgetFilial) {
        this.setTabbedFilialDefaultValues(widgetFilial);
        widgetFilial.currentRow.changed = false;
        widgetFilial.list();
        ativaTabbed(widgetFilial);
    };
    
    this.saveTabbedFilial = function(widgetFilial) {
        if(widgetFilial.isValid()){
            Cus00500_ParametrosDeCustos_Service.updateTabbedFilial(widgetFilial.currentRow).then(function(success) {
                ScreenService.notificationMessage("Alterações realizadas com sucesso!", 'success');
                this.setTabbedFilialDatasourceFilter(widgetFilial);
                widgetFilial.currentRow.changed = false;
                widgetFilial.list();
                ativaTabbed(widgetFilial);
            }.bind(this)).catch(function(e){
                ScreenService.showMessage(e);
            });
        }
    };
    
    this.widgetEditByName = function(widgetName){
        var widget = templateManager.container.getWidget(widgetName);
        widget.edit();
        widget.active = true;
        widget.container.eachWidget(function (widgetTabbed) {
			if (widgetTabbed.mode === "list") {
				widgetTabbed.enabled = false;
			}
		});
        widget.childTemplate = "widget/form.html";
        templateManager.updateTemplate();
        widget.activate();
    };
    
    this.openCopyCostParametersPopup = function(widgetFilial) {
		var popup = widgetFilial.container.getWidget('copyCostParametersPopup');
			
		ScreenService.openPopup(popup);
		popup.newRow();
		popup.currentRow.widgetCall = widgetFilial.name;
	};
	
	this.cancelPopup = function(popupWidget) {
		popupWidget.container.getWidget(popupWidget.currentRow.widgetCall).activate();
		ScreenService.closePopup();
		popupWidget.isVisible = false;
	};
	
	this.copyCostParameters = function(popupWidget) {
	    if (popupWidget.isValid()) {
    	    var widgetFilial = popupWidget.container.getWidget(popupWidget.currentRow.widgetCall);
    	    
    	    popupWidget.currentRow.CDFILIAL.forEach(function(filial) {
    	        var row = {
        	        CDFILIAL: filial,
        	        VRDIFCUSTACAO: widgetFilial.currentRow.VRDIFCUSTACAO,
                    IDCOMCUSPERC: widgetFilial.currentRow.IDCOMCUSPERC
        	    };
        	    
    	        Cus00500_ParametrosDeCustos_Service.updateTabbedFilial(row);
    	    });
    	    
    	    this.cancelPopup(popupWidget);
    	    ScreenService.showMessage("Parâmetros de Custos copiados com sucesso!");
	    }
	};
    
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Cus00500_ParametrosDeCustos_Controller', Cus00500_ParametrosDeCustos_Controller);
});