var Cus01400_CurvaABCGeralPlanController = function(ScreenService, restEngine, maskEngine, ZhUtil, General, GeneralServices) {
	/* global getLocalVar, Util, Configuration, moment*/
	var dataSetTree;
	var parent;
	var codigo;
	var unidade;
	var produtoinicial;
	var produtofinal;
	var tipocusto;
	var interval;
	var filterReport;
	var self = this;
	var prepareFilterReport = function(row, widget) {
		filterReport = [];
		var assoc = {
			'S': 'Sim',
			'Y': 'Sim',
			'N': 'Não'
		};
		var fields = ['NMFILIAL', 'DTINTERVAL', 'NMTIPOCUSTO', 'NMPRODUTOINICIAL_NMPRODUTOFINAL', 'IDMATEPRIM', 'IDNESTOCAVEIS', 'IDCONSPERC', 'IDCONSFIXO'];
		fields.forEach(function(key){
			var field = widget.getField(key);
			if(field){
				var item = {
					'label': field.label,
					'value': typeof row[key] === 'object' ? row[key].start + ' até ' + row[key].end : row[key]
				};
				item.value = item.value === 'S' || item.value === 'Y' || item.value === 'N' ? assoc[item.value] : item.value;
				filterReport.push(item);
			} else if(key.indexOf('_') > -1){
				var produtos = key.split('_');
				var aux = {
					'label': 'Produto',
					'value': row[produtos[0]] + ' a ' + row[produtos[1]] 
				};
				filterReport.push(aux);
			}
		});
	};
	var beforeGenerateReport = function(callback){
		callback.metadata.filter = filterReport;
	};

	this.idVizualiza = function(widget) {
		if(widget.getField('REPORT_NAME').value() == 'CUS01401'){
			widget.getField('IDVISUALIZA').isVisible = true;
		}else {
			widget.getField('IDVISUALIZA').isVisible = false;
		}
	};

	this.setaNomeRelatorio = function(widget) {
		if (!widget.currentRow.CDFILIAL) {
			widget.newRow();
		}

		widget.currentRow.REPORT_NAME               = 'CUS01400';
		widget.currentRow.CDFILIAL                  = getLocalVar('CDFILIAL');
		widget.currentRow.NMFILIAL                  = getLocalVar('CDFILIAL') + ' | '+ getLocalVar('NMFILIAL');
		widget.currentRow.DTINTERVAL                = {};
		widget.currentRow.DTINTERVAL.start          = moment().format('DD/MM/YYYY');
		widget.currentRow.DTINTERVAL.formattedStart = moment().format('DD/MM/YYYY');
		widget.currentRow.DTINTERVAL.end            = moment().format('DD/MM/YYYY');
		widget.currentRow.DTINTERVAL.formattedEnd   = moment().format('DD/MM/YYYY');


		widget.getField('NMTIPOCUSTO').reload().then(callback => {
			let typeOfCost = callback.dataset.type_cost_lang;
			if(typeOfCost && typeOfCost.length){
				let currentCost = typeOfCost[0];
				
				widget.currentRow.NMTIPOCUSTO = currentCost.CDTIPOCUSTO + ' | ' + currentCost.NMTIPOCUSTO;
			}
		});
	};

	this.retornaCurvaABC = function(currentRow) {
		return restEngine.post('cus_relatorio#/cus01400_retorna_curva', {
			"requestType": "Row",
			"row": currentRow
		}, null, null, null, null, 350000);
	};

	this.excluiConsplanCus01400 = function() {
		return restEngine.post('cus_relatorio#/cus01400_exclui_consplan', {
			"requestType": "Row",
			"row": {}
		});
	};
	
	this.validaNivel = function(currentRow, field) {
        var mensagem = "O produto final não pode ser maior que o inicial.";
        var retorno = '';
        
        if(currentRow.CDPRODUTOINICIAL && currentRow.CDPRODUTOFINAL) {
            retorno = General.comparaPratoProduto(currentRow.CDPRODUTOINICIAL, currentRow.CDPRODUTOFINAL, getLocalVar('CDPICTPROD'));
            if (!retorno) {
                ScreenService.showMessage(mensagem);
                return false;
            }
            return true;
        }
        return false;
    };

	this.validaCampos = function(currentRow, widget, args) {
		let reportFormats = [
		    {
		        name: "pdf",
		        value: "PDF"
		    },
		    {
		        name: "xlsx",
		        value: "XLSX"
		    }
		];
	    if(widget.isValid() && self.validaNivel(currentRow)) {
			General.openReportPopup(widget, this.abreRelatorio, [widget, currentRow, args], reportFormats);
		}    
	};

	this.abreRelatorio = function (widget, currentRow, args, reportName) {	        
		if (widget.getField('IDMATEPRIM').checked || widget.getField('IDCONSFIXO').checked || widget.getField('IDCONSPERC').checked || widget.getField('IDNESTOCAVEIS').checked) {
			self.salvaFilial(widget);
			currentRow.DTINICIAL = currentRow.DTINTERVAL.start;
			currentRow.DTFINAL = currentRow.DTINTERVAL.end;
			currentRow.__report_name = currentRow.REPORT_NAME;
			currentRow.DTMESINIC = moment(currentRow.DTINICIAL, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
			currentRow.DTMESFINA = moment(currentRow.DTFINAL, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY');
			let IDMATEPRIM = widget.getField('IDMATEPRIM').checked ? 'C' : 'X';
			let IDCONSFIXO = widget.getField('IDCONSFIXO').checked ? 'F' : 'X';
			let IDCONSPERC= widget.getField('IDCONSPERC').checked ? 'P' : 'X';
			currentRow.IDPRODUTOS = IDMATEPRIM + IDCONSFIXO + IDCONSPERC;
			currentRow.CDPICTPROD = '!' + getLocalVar('CDPICTPROD').replace(/[^(/\.|\ )]/g, "@");
			
			General.openReport('cus_relatorio#/cus01400_curva_abc_geral_planejado', currentRow.__report_name, args.row);
			/*this.retornaCurvaABC(currentRow).then(function(callback) {
				dataSetTree = callback.dataset.cus01400_abcgeralplan;
				if(!dataSetTree.length) {
					ScreenService.showMessage("Não há dados a serem listados.");
				} else {
					produtoinicial = widget.currentRow.NMPRODUTOINICIAL;
					produtofinal = widget.currentRow.NMPRODUTOFINAL;
					tipocusto = widget.currentRow.NMTIPOCUSTO;
					interval = widget.currentRow.DTINTERVAL;
					//prepareFilterReport(currentRow, widget);
					//ScreenService.openWindow('cus_relatorio#cus01400_grid_relatorio_plan');
				}
			}, function(erro) {
				ScreenService.showMessage('Operação não realizada. <br>Verifique sua conexão e tente novamente.');
			});*/
		} else {
			ScreenService.showMessage("O Tipo de Produto deve ser informado");
		}	
	};

	this.setaStripe = function(stripeWidget, parent) {
		stripeWidget.getField('unidade').setValue(codigo + ' - ' + unidade);
		stripeWidget.getField('NMTIPOCUSTO').setValue(tipocusto);
		stripeWidget.getField('NMPRODUTOFINAL').setValue(produtofinal);
		stripeWidget.getField('NMPRODUTOINICIAL').setValue(produtoinicial);
		stripeWidget.getField('INTERVAL').setValue(interval.start + ' a ' + interval.end);

		if (parent.length) {
	        parent[0].CUSTOTOTPROD = applyMask(parent[0].CUSTOTOTPROD, 5);
			stripeWidget.getField('custoTotal').setValue(parent[0].CUSTOTOTPROD);
		}
	};

	var applyMask = function(fieldValue, maxlength) {
        var mask = {
            "type": "zerofill",
            "params": {
                "right": true,
                "maxlength": maxlength
            }
		};
		
        return Util.applyMask(fieldValue, mask, maskEngine, ZhUtil);
    };

	this.setaDataSet = function(gridWidget, stripeWidget) {
		gridWidget.activate();
		parent = dataSetTree.splice(0, 1);
		this.setaStripe(stripeWidget, parent);
		gridWidget.dataSource.data = dataSetTree;
		gridWidget.beforeGenerateReport = beforeGenerateReport;
	};
	
	this.salvaFilial = function(widget) {
		codigo  = widget.currentRow.CDFILIAL;
		unidade = widget.currentRow.NMFILIAL;
	};
	
	this.alteraProdutoFinal = function(field){
		let widget = field.widget;
		if(field.name === 'NMPRODUTOINICIAL'){
		  widget.currentRow.NMPRODUTOFINAL = angular.copy(widget.currentRow.NMPRODUTOINICIAL);
		  widget.currentRow.CDPRODUTOINICIAL = angular.copy(widget.currentRow.CDPRODUTO);
		  widget.currentRow.CDPRODUTOFINAL = angular.copy(widget.currentRow.CDPRODUTO);
		} else {
			widget.currentRow.CDPRODUTOFINAL = angular.copy(widget.currentRow.CDPRODUTO);
		}
	};
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Cus01400_CurvaABCGeralPlanController', Cus01400_CurvaABCGeralPlanController);
});